<?php

##########################################################################################
# In order to be able to use this script you need to join the merchant program depending on the country where your store is selling the products
#
# AUSTRALIA - http://shopmania.com.au/ (only supporting AUD, NZD datafeeds)
# ARGENTINA - http://www.shopmania.com.ar/ (only supporting ARS, EUR, USD)       *NEW
# BRASIL - http://www.shopmania.com.br/ (only supporting BRL, USD) 
# BULGARY - http://www.shopmania.bg/ (only supporting BGN, EUR, USD)
# CZECH REPUBLIC - http://www.shop-mania.cz/ (only supporting CZK, EUR, USD)		*NEW
# CHILE - http://www.shopmania.cl/ (only supporting CLP, USD, EUR)       *NEW
# CHINA - http://www.shopmania.cn/ (only supporting CNY, USD)       
# DEUTSCHLAND - http://www.shopmania.de/ (only supporting EUR, USD) 
# FRANCE - http://www.shopmania.fr/ (only supporting EUR, USD datafeeds)
# HUNGARY - http://www.shopmania.hu/ (only supporting HUF, EUR, USD datafeeds)
# INDIA - http://www.shopmania.in/ (only supporting INR, USD datafeeds)
# IRELAND - http://www.shopmania.ie/ (only supporting EUR, GBP datafeeds)
# ITALY - http://www.shopmania.it/ (only supporting EUR, USD datafeeds)
# JAPAN - http://www.shopmania.jp/  (only supporting JPY, USD datafeeds)       
# MEXICO - http://www.shopmania.com.mx/ (only supporting MXN (Mexican peso), USD, EUR datafeeds)
# NETHERLANDS - http://www.shopmania.nl/ (only supporting EUR datafeeds)		*NEW
# POLSKA - http://www.shopmania.pl/ (only supporting PLN, EUR, USD) 
# PORTUGAL - http://www.shopmania.pt/ (only supporting EUR, USD) 
# ROMANIA - http://www.shopmania.ro/ (only supporting RON, EUR, USD datafeeds)
# RUSSIA - http://www.shopmania.ru/ (only supporting RUB, EUR, USD)       
# SERBIA - http://www.shopmania.rs/ (only supporting RSD, EUR)		*NEW	
# SLOVAKIA - http://www.shop-mania.sk/ (only supporting EUR, USD)
# SOUTH AFRICA - http://www.shopmania.co.za/ (only supporting ZAR, USD, EUR)       *NEW
# SPAIN - http://www.shopmania.es/ (only supporting EUR datafeeds) 
# SWEDEN - http://www.shopmania.se/ (only supporting SEK, EUR, USD datafeeds)		*NEW
# TURKEY - http://www.shopmania.com.tr/ (only supporting TRY, EUR, USD)
# US - http://www.shopmania.com/ (only supporting USD, CAD datafeeds)
# UK - http://www.shopmania.co.uk/ (only supporting GBP, EUR, USD datafeeds)
#
# Once you join the program and your application is approved you need to place the file on your server and set up the path to the file on the Merchant Interface
# Files will be  retrieved daily from your server having the products listed automatically on ShopMania
# 
# 
# Options
# @url_param taxes=on (on,off) 
# @url_param storetaxes=on (on,off) 
# @url_param discount=on (on,off) 
# @url_param add_vat=off (on,off) 
# @url_param vat_value=24 (VAT_VALUE) 
# @url_param shipping=off (on,off) 
# @url_param add_tagging=on (on,off) 
# @url_param tagging_params=utm_source=shopmania&utm_medium=cpc&utm_campaign=direct_link (TAGGING_PARAMS) 
# @url_param description=on (on,off) 
# @url_param image=on (on,off) 
# @url_param specialprice=on (on,off) 
# @url_param sef=off (on,off) 
# @url_param on_stock=off (on,off) 
# @url_param forcepath=off (on,off) 
# @url_param forcefolder= (FORCEFOLDER) 
# @url_param language= (LANGUAGE_CODE) 
# @url_param language_id= (LANGUAGE_ID) 
# @url_param currency= (CURRENCY_CODE) 
#
#  
##########################################################################################

// Current datafeed script version
$script_version = "1.05";

// Print current Script version
if (@$_GET['get'] == "version") {
	echo "<b>Datafeed OOS-Shop</b><br />";
	echo "script version <b>" . $script_version . "</b><br />";
	exit;
}

if (!ini_get("safe_mode")) {
    set_time_limit(0);
}
ignore_user_abort();
error_reporting(E_ALL^E_NOTICE);
$_SVR = array();

# If you use a default configuration you need to do place this file in your /catalog/ directory. 
# Otherwise if you place this file in another directory please modify the line below with the path to the catalog directory. 


##### Include configuration files ################################################
$site_base_path = "./";

# Once all is set up you need to check the result and make sure the output is correct
# Point the browser to http://www.example.com/path_to_datafeed/shopmania_datafeed.php and look into the source code of the out put
# What you need to see is something like this
# Category | Manufacturer | Part Number | Merchant Code | Product Name | Product Description | Product URL | Product Image URL | Product Price | Currency 

##### Avoid any modifications below this line #####

define('OOS_VALID_MOD', 'yes');

if (!defined('OOS_BASE_PRICE')) {
	define('OOS_BASE_PRICE', 'false');
}

// Include required files
if(!file_exists($site_base_path . "includes/oos_main.php")) {
	exit('<HTML><HEAD><TITLE>404 Not Found</TITLE></HEAD><BODY><H1>Not Found</H1>Please ensure that datafeed_shopmania_oos_shop.php is in the catalog directory, or make sure the path to the catalog directory is defined corectly above in $catalog_path variable</BODY></HTML>');
}
else {
	require($site_base_path . "includes/oos_main.php");	
}

// Check versions constants
if (sizeof($oostable) > 0 && is_array($oostable)) {
	$ver = "1.2";
	$table_arr = $oostable;	
}
else {
	$ver = "1.3";
	$table_arr = $oosDBTable;	
}

####################################################################


// Datafeed specific settings
$datafeed_separator = "|"; // Possible options are \t or |


##### Extract params from url ################################################

$apply_taxes = (@$_GET['taxes'] == "off") ? "off" : "on";
$apply_storetaxes = (@$_GET['storetaxes'] == "off") ? "off" : "on";
$apply_discount = (@$_GET['discount'] == "off") ? "off" : "on";
$add_vat = (@$_GET['add_vat'] == "on") ? "on" : "off";
$vat_value = (@$_GET['vat_value'] > 0) ? ((100 + $_GET['vat_value']) / 100) : 1.24; // default value
$add_shipping = (@$_GET['shipping'] == "on") ? "on" : "off";
$add_tagging = (@$_GET['add_tagging'] == "off") ? "off" : "on";
$tagging_params = (@$_GET['tagging_params'] != "") ? urldecode($_GET['tagging_params']) : "utm_source=shopmania&utm_medium=cpc&utm_campaign=direct_link";
$show_description = (@$_GET['description'] == "off") ? "off" : "on";
$show_image = (@$_GET['image'] == "off") ? "off" : "on";
$show_specialprice = (@$_GET['specialprice'] == "off") ? "off" : "on";
$sef = (@$_GET['sef'] == "on") ? "on" : "off";
$on_stock_only = (@$_GET['on_stock'] == "on") ? "on" : "off";
$force_path = (@$_GET['forcepath'] == "on") ? "on" : "off";
$force_folder = (@$_GET['forcefolder'] != "") ? $_GET['forcefolder'] : "";
$language_code = (@$_GET['language'] != "") ? $_GET['language'] : "";
$language_id = (@$_GET['language_id'] != "") ? $_GET['language_id'] : "";
$currency = (@$_GET['currency'] != "") ? $_GET['currency'] : "";

####################################################################


// Print URL options
if (@$_GET['get'] == "options") {
	$script_basepath = "http://" . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'];
	
	echo "<b>Datafeed OOS-Shop</b><br />";
	echo "script version <b>" . $script_version . "</b><br /><br /><br />";
		
	//echo "Taxes options - possible values on, off default value on<br />";
	//echo "taxes=on (on,off) <a href=\"" . $script_basepath . "?taxes=off" . "\" >" . $script_basepath . "?taxes=off" . "</a><br /><br />";
	
	//echo "Store taxes options - possible values on, off default value on<br />";
	//echo "storetaxes = on (on,off) <a href=\"" . $script_basepath . "?storetaxes=off" . "\" >" . $script_basepath . "?storetaxes=off" . "</a><br /><br />";
	
	//echo "Discount options - possible values on, off default value on<br />";
	//echo "discount=on (on,off) <a href=\"" . $script_basepath . "?discount=off" . "\" >" . $script_basepath . "?discount=off" . "</a><br /><br />";
	
	echo "<b>Add VAT to prices</b> - possible values on, off default value off<br />";
	echo "add_vat=off (on,off) <a href=\"" . $script_basepath . "?add_vat=on" . "\" >" . $script_basepath . "?add_vat=on" . "</a><br /><br />";
	
	echo "VAT value - possible values percent value default value 24  - interger or float number ex 19 or 19.5<br />";
	echo "vat_value=24 (VAT_VALUE) <a href=\"" . $script_basepath . "?add_vat=on&vat_value=19" . "\" >" . $script_basepath . "?add_vat=on&vat_value=19" . "</a><br /><br />";
	
	//echo "Add shipping to datafeed - possible values on, off default value off<br />";
	//echo "shipping=off (on,off) <a href=\"" . $script_basepath . "?shipping=off" . "\" >" . $script_basepath . "?shipping=off" . "</a><br /><br />";
	
	echo "Add GA Tagging to product URL - possible values on, off default value on<br />";
	echo "add_tagging=on (on,off) <a href=\"" . $script_basepath . "?add_tagging=off" . "\" >" . $script_basepath . "?add_tagging=off" . "</a><br /><br />";
	
	echo "<b>Add custom Tagging to product URL</b> - possible values url_encode(TAGGING_PARAMS) default value tagging_params=utm_source=shopmania&utm_medium=cpc&utm_campaign=direct_link<br />";
	echo "tagging_params=utm_source=shopmania&utm_medium=cpc&utm_campaign=direct_link (TAGGING_PARAMS) <a href=\"" . $script_basepath . "?tagging_params=from%3Dshopmania" . "\" >" . $script_basepath . "?tagging_params=from%3Dshopmania" . "</a><br /><br />";
	
	//echo "Display Description options - possible values on, off<br />";
	//echo "description=on (on,off) <a href=\"" . $script_basepath . "?description=off" . "\" >" . $script_basepath . "?description=off" . "</a><br /><br />";

	//echo "Display image options - possible values on, off default value on<br />";
	//echo "image=on (on,off) <a href=\"" . $script_basepath . "?image=off" . "\" >" . $script_basepath . "?image=off" . "</a><br /><br />";
	
	//echo "Special price options - possible values on, off default value on<br />";
	//echo "specialprice=on (on,off) <a href=\"" . $script_basepath . "?specialprice=off" . "\" >" . $script_basepath . "?specialprice=off" . "</a><br /><br />";
	
	//echo "Show only on stock products - possible values on, off default value off<br />";
	//echo "on_stock=off (on,off) <a href=\"" . $script_basepath . "?on_stock=on" . "\" >" . $script_basepath . "?on_stock=on" . "</a><br /><br />";
	
	//echo "Show SEO friendly url - possible values on, off default value off<br />";
	//echo "sef=off (on,off) <a href=\"" . $script_basepath . "?sef=on" . "\" >" . $script_basepath . "?sef=on" . "</a><br /><br />";
	
	//echo "Get prices in specified currency - possible values USD,EUR etc. <br />";
	//echo "currency=DEFAULT_CURRENCY <a href=\"" . $script_basepath . "?currency=EUR" . "\" >" . $script_basepath . "?currency=EUR" . "</a><br /><br />";
	
	//echo "Get texts in specified language code - possible values en,ro etc. <br />";
	//echo "language=DEFAULT_LANGUAGE_CODE <a href=\"" . $script_basepath . "?language=en" . "\" >" . $script_basepath . "?language=en" . "</a><br /><br />";
	
	//echo "Get texts in specified language id - possible values 1,2 etc. <br />";
	//echo "language_id=DEFAULT_LANGUAGE_ID <a href=\"" . $script_basepath . "?language_id=1" . "\" >" . $script_basepath . "?language_id=1" . "</a><br /><br />";
	
	echo "<br />";
	
	exit;
	
}

##### Extract options from database ################################################

$already_sent = array();

// Get all categories
$cat_info_sql = "SELECT " . $table_arr['categories'] . ".categories_id, " . $table_arr['categories'] . ".parent_id, " . $table_arr['categories_description'] . ".categories_languages_id, " . $table_arr['categories_description'] . ".categories_name
FROM " . $table_arr['categories'] . " 
LEFT JOIN " . $table_arr['categories_description'] . " ON ( " . $table_arr['categories_description'] . ".categories_id = " . $table_arr['categories'] . ".categories_id AND " . $table_arr['categories_description'] . ".categories_languages_id = '" . intval($nLanguageID) . "')";
if ($ver == "1.2") {
	$cat_info_result = $dbconn->Execute($cat_info_sql);
}
else {
	$cat_info_result = $db->Execute($cat_info_sql);
}
$CAT_ARR = array();
while ($cat_info = $cat_info_result->fields) {
	$CAT_ARR[$cat_info['categories_id']] = $cat_info;
	$cat_info_result->MoveNext();
}

// Get manufacturers
$manuf_info_sql = "SELECT manufacturers_id, manufacturers_name FROM " . $table_arr['manufacturers'];
if ($ver == "1.2") {
	$manuf_info_result = $dbconn->Execute($manuf_info_sql);
}
else {
	$manuf_info_result = $db->Execute($manuf_info_sql);
}
$MANUF_ARR = array();
while ($manuf_info = $manuf_info_result->fields) {
	$MANUF_ARR[$manuf_info['manufacturers_id']] = $manuf_info;
	$manuf_info_result->MoveNext();
}

######################################################################


##### Extract products from database ###############################################

// Get products
$product_info_sql = "SELECT p.products_id, pd.products_name, pd.products_description, pd.products_url,
	pd.products_description_meta, pd.products_keywords_meta, p.products_model,
	p.products_quantity, p.products_image, p.products_subimage1, p.products_subimage2,
	p.products_subimage3, p.products_subimage4, p.products_subimage5, p.products_subimage6,
	p.products_discount_allowed, p.products_price, p.products_base_price, p.products_base_unit,
	p.products_quantity_order_min, p.products_quantity_order_units,
	p.products_discount1, p.products_discount2, p.products_discount3, p.products_discount4,
	p.products_discount1_qty, p.products_discount2_qty, p.products_discount3_qty,
	p.products_discount4_qty, p.products_tax_class_id, p.products_date_added,
	p.products_date_available, p.manufacturers_id, p.products_price_list, p2c.categories_id
	FROM " . $table_arr['products'] . " p,
	" . $table_arr['products_description'] . " pd, 
	" . $table_arr['products_to_categories'] . " p2c
	WHERE p.products_status >= '1'
	AND pd.products_id = p.products_id
	AND pd.products_languages_id = '" . intval($nLanguageID) . "'
	AND p2c.products_id = p.products_id";
	

if ($ver == "1.2") {
	$product_info_result = $dbconn->Execute($product_info_sql);
}
else {
	$product_info_result = $db->Execute($product_info_sql);
}

###################################################################


##### Print product data ####################################################

while ($product_info = $product_info_result->fields) {

	// If we've sent this one, skip the rest - this is to ensure that we do not get duplicate products
	if ($already_sent[$product_info['products_id']] == 1) continue;
	
	$info_product_price = '';
    $info_product_special_price = '';
    $info_product_discount = 0;
    $info_product_discount_price = '';
    $info_base_product_price = '';
    $info_base_product_special_price = '';
    $info_product_price_list = 0;
    $info_special_price = '';
    
	$info_product_price = oos_add_tax($product_info['products_price'], oos_get_tax_rate($product_info['products_tax_class_id']));

	if ($info_special_price = oos_get_products_special_price($product_info['products_id'])) {
		$info_product_special_price = oos_add_tax($info_special_price, oos_get_tax_rate($product_info['products_tax_class_id']));
	} 
	else {
		$info_product_discount = min($product_info['products_discount_allowed'], $_SESSION['member']->group['discount']);

		if ($info_product_discount != 0 ) {
			$info_product_special_price = $product_info['products_price']*(100-$info_product_discount)/100;
			$info_product_discount_price = oos_add_tax($info_product_special_price, oos_get_tax_rate($product_info['products_tax_class_id']));
		}
	}

	if ($product_info['products_base_price'] != 1) {
		$info_base_product_price = oos_add_tax($product_info['products_price'] * $product_info['products_base_price'], oos_get_tax_rate($product_info['products_tax_class_id']));

		if ($info_product_special_price != '') {			
			$info_base_product_special_price = oos_add_tax($info_product_special_price * $product_info['products_base_price'], oos_get_tax_rate($product_info['products_tax_class_id']));
		}
	}
	
	if (OOS_BASE_PRICE == 'false') {		
		$info_product_price_list = oos_add_tax($product_info['products_price_list'], oos_get_tax_rate($product_info['products_tax_class_id']));
	}
	
	if ($info_product_special_price > 0) {
		$product_info['final_price'] = $info_product_special_price;
	}
	else {
		$product_info['final_price'] = $info_product_price;
	}
	
	// Add VAT to prices
	if ($add_vat == "on") {
		$product_info['final_price'] = $product_info['final_price'] * $vat_value;
	}
	
	$rate = $oCurrencies->currencies[$_SESSION['currency']]['value'];
	$product_info['final_price'] = number_format($product_info['final_price'] * $rate, $oCurrencies->currencies[$_SESSION['currency']]['decimal_places'], $oCurrencies->currencies[$_SESSION['currency']]['decimal_point'], $oCurrencies->currencies[$_SESSION['currency']]['thousands_point']);
	$product_info['currency'] = $_SESSION['currency'];

	
	// Clean description
	$product_info['products_description'] = smfeed_clean_description($product_info['products_description']);
	
	// Clean product name (new lines)	
	$product_info['products_name'] = str_replace("\n", " ", strip_tags($product_info['products_name']));		
	$product_info['products_name'] = str_replace("\r", "", strip_tags($product_info['products_name']));
	$product_info['products_name'] = str_replace("\t", " ", strip_tags($product_info['products_name']));
	
	// Clean product description (Replace new line with <BR>). In order to make sure the code does not contains other HTML code it might be a good ideea to strip_tags()	
	$product_info['products_description'] = smfeed_replace_not_in_tags("\n", "<BR />", $product_info['products_description']);
	$product_info['products_description'] = str_replace("\n", " ", $product_info['products_description']);    
	$product_info['products_description'] = str_replace("\r", "", $product_info['products_description']);
	$product_info['products_description'] = str_replace("\t", " ", $product_info['products_description']);
	
	// Get category name
	$product_info['category_name'] = smfeed_get_full_cat($product_info['categories_id'], $CAT_ARR);
	
	// URL
	if ($ver == "1.2") {
		$product_info['product_url'] = oos_href_link($aModules['products'], $aFilename['product_info'], 'products_id=' . intval($product_info['products_id']));
		// Extra cleaning
		while (strstr($product_info['product_url'], '&amp;')) $product_info['product_url'] = str_replace('&amp;', '&', $product_info['product_url']);
	    while (strstr($product_info['product_url'], '&&')) $product_info['product_url'] = str_replace('&&', '&', $product_info['product_url']);
	}
	else {
		$product_info['product_url'] = oos_link($aModules['products'], $aFilename['product_info'], 'products_id=' . intval($product_info['products_id']));
	}
	
	// Image
	if ($ver == "1.2") {
		if (file_exists(OOS_ABSOLUTE_PATH . OOS_IMAGES . OOS_POPUP_IMAGES . $product_info['products_image'])) {
			$product_info['image_url'] = OOS_HTTP_SERVER . OOS_SHOP . OOS_IMAGES . OOS_POPUP_IMAGES . $product_info['products_image'];
		} else {
			$product_info['image_url'] = OOS_HTTP_SERVER . OOS_SHOP . OOS_IMAGES . $product_info['products_image'];
		}
	}
	else {
		if (file_exists(OOS_SHOP_PATH . OOS_IMAGES . OOS_IMAGE_SUBDIR . $product_info['products_image'])) {
			$product_info['image_url'] = OOS_HTTP_SERVER . OOS_SHOP . OOS_IMAGES . OOS_IMAGE_SUBDIR . $product_info['products_image'];
		} else {
			$product_info['image_url'] = OOS_HTTP_SERVER . OOS_SHOP . OOS_IMAGES . $product_info['products_image'];
		}
	}
	
	// Add GA Tagging parameters to url
	if ($add_tagging == "on") {
		$and_param = (preg_match("/\?/", $product_info['image_url'])) ? "&" : "?";
		$product_info['image_url'] = $product_info['image_url'] . $and_param . $tagging_params;
	}
	
	// Clean product names and descriptions (separators)
	if ($datafeed_separator == "\t") {
		$product_info['category_name'] = str_replace("\t", " ", $product_info['category_name']);
		// Continue... tabs were already removed
	}
	elseif ($datafeed_separator == "|") {
		$product_info['products_name'] = str_replace("|", " ", strip_tags($product_info['products_name']));
		$product_info['products_description'] = str_replace("|", " ", $product_info['products_description']);
		$product_info['products_model'] = str_replace("|", " ", $product_info['products_model']);
		$product_info['category_name'] = str_replace("|", " ", $product_info['category_name']);
	}
	else {
		print "Incorrect columns separator.";
		exit;			
	}	
		
	print 
		$product_info['category_name'] . $datafeed_separator .
		$MANUF_ARR[$product_info['manufacturers_id']]['manufacturers_name'] . $datafeed_separator .
		$product_info['products_model'] . $datafeed_separator .
		$product_info['products_id'] . $datafeed_separator .
		$product_info['products_name'] . $datafeed_separator .
		$product_info['products_description'] . $datafeed_separator .
		$product_info['product_url'] . $datafeed_separator .
		$product_info['image_url'] . $datafeed_separator .
		$product_info['final_price'] . $datafeed_separator .
		$product_info['currency'] . "\n";
	
	$already_sent[$product_info['products_id']] = 1;
		
	$product_info_result->MoveNext();
}

######################################################################


##### Functions ############################################################

// Function to get category with full path
function smfeed_get_full_cat($cat_id, $CATEGORY_ARR) {

	$item_arr = $CATEGORY_ARR[$cat_id];
	$cat_name = $item_arr['categories_name'];
	
	while (sizeof($CATEGORY_ARR[$item_arr['parent_id']]) > 0 && is_array($CATEGORY_ARR[$item_arr['parent_id']]) ) {
		
		$cat_name = $CATEGORY_ARR[$item_arr['parent_id']]['categories_name'] . " > " . $cat_name;		
		$item_arr = $CATEGORY_ARR[$item_arr['parent_id']];
	}
	
	// Strip html from category name
	$cat_name = smfeed_html_to_text($cat_name);
	
	return $cat_name;
}

function smfeed_html_to_text($string){

	$search = array (
		"'<script[^>]*?>.*?</script>'si",  // Strip out javascript
		"'<[\/\!]*?[^<>]*?>'si",  // Strip out html tags
		"'([\r\n])[\s]+'",  // Strip out white space
		"'&(quot|#34);'i",  // Replace html entities
		"'&(amp|#38);'i",
		"'&(lt|#60);'i",
		"'&(gt|#62);'i",
		"'&(nbsp|#160);'i",
		"'&(iexcl|#161);'i",
		"'&(cent|#162);'i",
		"'&(pound|#163);'i",
		"'&(copy|#169);'i",
		"'&(reg|#174);'i",
		"'&#8482;'i",
		"'&#149;'i",
		"'&#151;'i"
		);  // evaluate as php
	
	$replace = array (
		" ",
		" ",
		"\\1",
		"\"",
		"&",
		"<",
		">",
		" ",
		"&iexcl;",
		"&cent;",
		"&pound;",
		"&copy;",
		"&reg;",
		"<sup><small>TM</small></sup>",
		"&bull;",
		"-",
		);
	
	$text = preg_replace ($search, $replace, $string);
	return $text;
	
}

function smfeed_clean_description($string){

	$search = array (
		"'<html>'i",
		"'</html>'i",
		"'<body>'i",
		"'</body>'i",
		"'<head>.*?</head>'si",
		"'<!DOCTYPE[^>]*?>'si"
		); 
		
	$replace = array (
		"",
		"",
		"",
		"",
		"",
		""
		); 
		
	$text = preg_replace ($search, $replace, $string);
	return $text;

}

function smfeed_replace_not_in_tags($find_str, $replace_str, $string) {
	
	$find = array($find_str);
	$replace = array($replace_str);	
	preg_match_all('#[^>]+(?=<)|[^>]+$#', $string, $matches, PREG_SET_ORDER);	
	foreach ($matches as $val) {	
		if (trim($val[0]) != "") {
			$string = str_replace($val[0], str_replace($find, $replace, $val[0]), $string);
		}
	}	
	return $string;
}

######################################################################

exit;

?>